Solved

C# async problem

Posted on 2014-03-25
15
299 Views
Last Modified: 2014-03-28
I'm trying to debug code with Task based async, but any error generated in the 'task' seems to bubble straight up the call stack.
I've tried Debug-Exceptiones/ and just clicked the CLR node but then it stops on everything...
0
Comment
Question by:Silas2
  • 6
  • 4
  • 4
15 Comments
 
LVL 74

Expert Comment

by:käµfm³d 👽
ID: 39953528
seems to bubble straight up the call stack.
Does the stack trace not tell you where the error is occurring?
0
 

Author Comment

by:Silas2
ID: 39953552
The stack trace would be great but as its not breaking on the error by the time you realise an exception is thrown, the call stack is for the handling code, not the faulting code.
0
 
LVL 44

Expert Comment

by:AndyAinscow
ID: 39953591
I'm not clear what you mean.  Is the following roughly what is happening?
You have a try...catch block in foo.  In that try...catch block you call foo2, which calls foo3, which calls foo4 ..... which calls fooXXX and somewhere in that an exception is thrown.
0
 

Author Comment

by:Silas2
ID: 39953610
No, no try/catch in my code - I want to see all my errors!
I run a async task-based pattern to execute a procedure (with no try/catch block in), the procedure faults, I'm hoping to see which line, but the fault is caught in the task-asnyc calling bit, with no record of which line in my code threw the exception.

Its as if the async task pattern has a try/catch block on everything inside it so you can't trace the fault.
0
 
LVL 44

Expert Comment

by:AndyAinscow
ID: 39953650
>>No, no try/catch in my code - I want to see all my errors!

Oh dear.  The whole point of try....catch is to trap an error AND DISPLAY IT IF REQUIRED at a point where you can easily locate what is the faulting code.
0
 

Author Comment

by:Silas2
ID: 39953684
I never use error handling for 'normal flow' in my code, just for unpredictable activities, like talking to the outside world, file I/O etc. Normal flow shouldn't throw errors, everything should be pre-empted by the logic.
That's a coding style I've been using for 20 years...but don't get me started on overuse of error handling code.
But that isn't germane to this issue really which is that the error handling in the Task/Async pattern in over-zealous and handling unhandled errors when I want to break there.
Toggling the Debug-Exceptions/CLR seems to be the only way I've found.
0
 
LVL 44

Expert Comment

by:AndyAinscow
ID: 39953745
OK, I'll bow out to your expertise in writing error free code in that case.
0
How to run any project with ease

Manage projects of all sizes how you want. Great for personal to-do lists, project milestones, team priorities and launch plans.
- Combine task lists, docs, spreadsheets, and chat in one
- View and edit from mobile/offline
- Cut down on emails

 
LVL 74

Expert Comment

by:käµfm³d 👽
ID: 39953813
When the error bubbles up, is there anything in the InnerException property?
0
 
LVL 44

Expert Comment

by:AndyAinscow
ID: 39953821
I'll asked for this to be reopened.  That comment is not an answer.
0
 

Author Comment

by:Silas2
ID: 39953915
is there anything in the InnerException property?
There doesn't seem to be any exception thrown in the asnyc task (CLR) code, it's just catching my exception and ignoring it.

I am having to toggle the Debug-Exceptions-Thow All CLR check box - which is a tedious workaround...
0
 
LVL 74

Expert Comment

by:käµfm³d 👽
ID: 39954084
I can relate to having to flip back and forth through Debug->Exceptions.

As to your issue, have you read through the following yet?

http://msdn.microsoft.com/en-us/library/dd997415(v=vs.110).aspx

Shall we assume that the behavior you are witnessing is different than what this document proposes?
0
 

Author Comment

by:Silas2
ID: 39954113
I think the phenomenon is the one described in the document, but that doesn't really help when debugging, in the sense that the document suggests:
var task1 = Task.Factory.StartNew(() =>
{
    throw new MyCustomException("I'm bad, but not too bad!");
});

try
{
    task1.Wait();
}
catch (AggregateException ae)
{
    // Assume we know what's going on with this particular exception. 
    // Rethrow anything else. AggregateException.Handle provides 
    // another way to express this. See later example. 
    foreach (var e in ae.InnerExceptions)
    {
        if (e is MyCustomException)
        {
            Console.WriteLine(e.Message);
        }
        else
        {
            throw;
        }
    }

}

Open in new window

whereas, for debug you want the code to actually break on the error, not a fancy-pants aggregated exception handler in the calling code.
I'm sure the old async patterns allowed you to break on exceptions without having to toggle the 'break on All exceptions' box. I suppose I could make a macro, but I think the VS macro recorder's been removed.
0
 
LVL 74

Accepted Solution

by:
käµfm³d   👽 earned 250 total points
ID: 39954239
I'm not certain it will answer your question, but the following explains why the AggregateException exists:

http://blogs.msdn.com/b/pfxteam/archive/2011/09/28/task-exception-handling-in-net-4-5.aspx

The section discussing <ThrowUnobservedTaskExceptions enabled="true"/> may be what you are after, though.
0
 

Author Comment

by:Silas2
ID: 39954251
Aaahhhh, yes that's very interesting. Thanks for that. I'll have a play around.
0

Featured Post

How to improve team productivity

Quip adds documents, spreadsheets, and tasklists to your Slack experience
- Elevate ideas to Quip docs
- Share Quip docs in Slack
- Get notified of changes to your docs
- Available on iOS/Android/Desktop/Web
- Online/Offline

Join & Write a Comment

Many of us here at EE write code. Many of us write exceptional code; just as many of us write exception-prone code. As we all should know, exceptions are a mechanism for handling errors which are typically out of our control. From database errors, t…
Wouldn’t it be nice if you could test whether an element is contained in an array by using a Contains method just like the one available on List objects? Wouldn’t it be good if you could write code like this? (CODE) In .NET 3.5, this is possible…
Illustrator's Shape Builder tool will let you combine shapes visually and interactively. This video shows the Mac version, but the tool works the same way in Windows. To follow along with this video, you can draw your own shapes or download the file…
Here's a very brief overview of the methods PRTG Network Monitor (https://www.paessler.com/prtg) offers for monitoring bandwidth, to help you decide which methods you´d like to investigate in more detail.  The methods are covered in more detail in o…

708 members asked questions and received personalized solutions in the past 7 days.

Join the community of 500,000 technology professionals and ask your questions.

Join & Ask a Question

Need Help in Real-Time?

Connect with top rated Experts

17 Experts available now in Live!

Get 1:1 Help Now